!------------------------------------------------------------------------------
!    This code is part of the MondoSCF suite of programs for linear scaling
!    electronic structure theory and ab initio molecular dynamics.
!
!    Copyright (2004). The Regents of the University of California. This
!    material was produced under U.S. Government contract W-7405-ENG-36
!    for Los Alamos National Laboratory, which is operated by the University
!    of California for the U.S. Department of Energy. The U.S. Government has
!    rights to use, reproduce, and distribute this software.  NEITHER THE
!    GOVERNMENT NOR THE UNIVERSITY MAKES ANY WARRANTY, EXPRESS OR IMPLIED,
!    OR ASSUMES ANY LIABILITY FOR THE USE OF THIS SOFTWARE.
!
!    This program is free software; you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by the
!    Free Software Foundation; either version 2 of the License, or (at your
!    option) any later version. Accordingly, this program is distributed in
!    the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
!    the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
!    PURPOSE. See the GNU General Public License at www.gnu.org for details.
!
!    While you may do as you like with this software, the GNU license requires
!    that you clearly mark derivative software.  In addition, you are encouraged
!    to return derivative works to the MondoSCF group for review, and possible
!    disemination in future releases.
!------------------------------------------------------------------------------

! The following Zippy quotes are taken from the "Vim global plugin for Zippy The Pinhead quotes".

MODULE ZippyQuote
  USE Order
  USE ControlStructures

  IMPLICIT NONE

CONTAINS
  !===========================================================================================================================
  ! LETS NOT TAKE OURSELVES TOO SERIOUSLY ...
  !===========================================================================================================================
  SUBROUTINE ZippySez(C)
    TYPE(Controls)  :: C
    INTEGER         :: N,PU

    CHARACTER(LEN=500), DIMENSION(807) :: quotes

    quotes(1)   = "Are we having fun yet?"
    quotes(2)   = "I am demographically correct."
    quotes(3)   = "I just became one with my browser software."
    quotes(4)   = "Virtual reality isn't what it used to be."
    quotes(5)   = "I want a mega-meal in a mega-mall."
    quotes(6)   = "Adopt my lifestyle or I'll have to press charges."
    quotes(7)   = "If you can't say something nice say something surrealistic."
    quotes(8)   = "I'm afraid! I need something in a heavy cream sauce."
    quotes(9)   = "I can silence Joan Rivers with a single slice of Kraft cheese."
    quotes(10)  = "I am protected by the power of stain-reistant Scotchguard"
    quotes(11)  = "I just accepted provolone into my life."
    quotes(12)  = "Frivolity is a stern taskmaster."
    quotes(13)  = "All life is a blur of Republicans and meat."
    quotes(14)  = "I'm Zippy the Pinhead and I'm totally committed to the festive mode."
    quotes(15)  = "I just felt a paradigm shift."
    quotes(16)  = "My boxer shorts just went on a rampage through a Long Island bowling alley."
    quotes(17)  = "Glazed donuts are the building blocks of the universe."
    quotes(18)  = "Nobody brings small problems into a laundromat."
    quotes(19)  = "Consciousness is vastly overrated."
    quotes(20)  = "I hope my sensitive female side is wearing sensible leather pumps."
    quotes(21)  = "Reality distorts my sense of television."
    quotes(22)  = "AIEEEEE!  I am having an UNDULATING EXPERIENCE!"
    quotes(23)  = "Am I accompanied by a PARENT or GUARDIAN?"
    quotes(24)  = "Am I in GRADUATE SCHOOL yet?"
    quotes(25)  = "Are we live or on tape?"
    quotes(26)  = "As a FAD follower my BEVERAGE choices are rich and fulfilling!"
    quotes(27)  = "BELA LUGOSI is my co-pilot.."
    quotes(28)  = "Can I have an IMPULSE ITEM instead?"
    quotes(29)  = "I used to be a FUNDAMENTALIST but then I heard about the HIGH RADIATION LEVELS and bought an ENCYCLOPEDIA!!"
    quotes(30)  = "Everywhere I look I see NEGATIVITY and ASPHALT..."
    quotes(31)  = "Half a mind is a terrible thing to waste!"
    quotes(32)  = "He is the MELBA-BEING...  the ANGEL CAKE... XEROX him...  XEROX him --"
    quotes(33)  = "Hmmm...  an arrogant bouquet with a subtle suggestion of POLYVINYL CHLORIDE..."
    quotes(34)  = "I can't decide which WRONG TURN to make first!!"
    quotes(35)  = "I guess you guys got BIG MUSCLES from doing too much STUDYING!"
    quotes(36)  = "I had pancake makeup for brunch!"
    quotes(37)  = "I just heard the SEVENTIES were over!!  And I was just getting in touch with my LEISURE SUIT!!"
    quotes(38)  = "I think I am an overnight sensation right now!!"
    quotes(39)  = "I think I'd better go back to my DESK and toy with a few common MISAPPREHENSIONS..."
    quotes(40)  = "I will SHAVE and buy JELL-O and bring my MARRIAGE MANUAL!!"
    quotes(41)  = "Impudent..  Yet possessing a certain ALUMINUM SILICATE overbite....Needs REDDY-WHIP!!"
    quotes(42)  = "If I had a Q-TIP, I could prevent th'collapse of NEGOTIATIONS!!"
    quotes(43)  = "If this was a SWEDISH MOVIE, I'd take off your GO-GO BOOTS!!"
    quotes(44)  = "Hand me a pair of leather pants and a CASIO keyboard -- I'm living for today!"
    quotes(45)  = "I'm using my X-RAY VISION to obtain a rare glimpse of the INNER WORKINGS of this POTATO!!"
    quotes(46)  = "A can of ASPARAGUS, 73 pigeons, some LIVE ammo, and a FROZEN DAQUIRI!!"
    quotes(47)  = "A dwarf is passing out somewhere in Detroit!"
    quotes(48)  = "A GRAM??  A BRAM...  A GROOM...  A BROOM...  Oh, Yeh!!  Wash the ROOM!!"
    quotes(49)  = "...A housewife is wearing a polypyrene jumpsuit!!"
    quotes(50)  = "A shapely CATHOLIC SCHOOLGIRL is FIDGETING inside my costume.."
    quotes(51)  = "A wide-eyed, innocent UNICORN, poised delicately in a MEADOW filled with LILACS, LOLLIPOPS & small CHILDREN at the HUSH of twilight??"
    quotes(52)  = "Actually, what I'd like is a little toy spaceship!!"
    quotes(53)  = "After this, I'm going to BURN some RUBBER!!"
    quotes(54)  = "After THIS, let's go to PHILADELPHIA and have TRIPLETS!!"
    quotes(55)  = "AIEEEEE!  I am having an UNDULATING EXPERIENCE!"
    quotes(56)  = "ALFRED JARRY!  Say something about th' DEATH of DISCO!!"
    quotes(57)  = "All I can think of is a platter of organic PRUNE CRISPS being trampled by an army of swarthy, Italian LOUNGE SINGERS..."
    quotes(58)  = "All of a sudden, I want to THROW OVER my promising ACTING CAREER, grow a LONG BLACK BEARD and wear a BASEBALL HAT!!  ...  Although I don't know WHY!!"
    quotes(59)  = "All of life is a blur of Republicans and meat!"
    quotes(60)  = "All right, you degenerates!  I want this place evacuated in 20 seconds!"
    quotes(61)  = "All this time I've been VIEWING a RUSSIAN MIDGET SODOMIZE a HOUSECAT!"
    quotes(62)  = "Alright, you!!  Imitate a WOUNDED SEAL pleading for a PARKING SPACE!!"
    quotes(63)  = "Am I accompanied by a PARENT or GUARDIAN?"
    quotes(64)  = "Am I elected yet?"
    quotes(65)  = "..Am I in a SOAP OPERA??"
    quotes(66)  = "Am I in GRADUATE SCHOOL yet?"
    quotes(67)  = "Am I SHOPLIFTING?"
    quotes(68)  = "America!!  I saw it all!!  Vomiting!  Waving!  JERRY FALWELLING into your void tube of UHF oblivion!!  SAFEWAY of the mind --"
    quotes(69)  = "An air of FRENCH FRIES permeates my nostrils!!"
    quotes(70)  = "An INK-LING?  Sure -- TAKE one!!  Did you BUY any COMMUNIST UNIFORMS??"
    quotes(71)  = "An Italian is COMBING his hair in suburban DES MOINES!"
    quotes(72)  = "And furthermore, my bowling average is unimpeachable!!!"
    quotes(73)  = "ANN JILLIAN'S HAIR makes LONI ANDERSON'S HAIR look like RICARDO MONTALBAN'S HAIR!"
    quotes(74)  = "Are BOTH T.V.S on??"
    quotes(75)  = "..  are the STEWED PRUNES still in the HAIR DRYER?"
    quotes(76)  = "..Are we having FUN yet...?"
    quotes(77)  = "Are we live or on tape?"
    quotes(78)  = "Are we on STRIKE yet?"
    quotes(79)  = "Are we THERE yet?"
    quotes(80)  = "Are we THERE yet?  My MIND is a SUBMARINE!!"
    quotes(81)  = "Are we THERE yet?!"
    quotes(82)  = "Are we THERE yet??"
    quotes(83)  = "Are you guys lined up for the METHADONE PROGRAM or FOOD STAMPS??"
    quotes(84)  = "Are you mentally here at Pizza Hut??"
    quotes(85)  = "Are you selling NYLON OIL WELLS??  If so, we can use TWO DOZEN!!"
    quotes(86)  = "Are you still an ALCOHOLIC?"
    quotes(87)  = "Are you still SEXUALLY ACTIVE?  Did you BRING th' REINFORCEMENTS?"
    quotes(88)  = "As a FAD follower, my BEVERAGE choices are rich and fulfilling!"
    quotes(89)  = "As President I have to go vacuum my coin collection!"
    quotes(90)  = "Ask me the DIFFERENCE between PHIL SoILVERS and ALEXANDER HAIG!!"
    quotes(91)  = "Awright, which one of you hid my PENIS ENVY?"
    quotes(92)  = "Bagels..."
    quotes(93)  = "BARBARA STANWYCK makes me nervous!!"
    quotes(94)  = "Barbie says, Take quaaludes in gin and go to a disco right away! But Ken says, WOO-WOO!!  No credit at ``Mr. Liquor''!!"
    quotes(95)  = "BARRY..  That was the most HEART-WARMING rendition of ``I DID IT MY WAY'' I've ever heard!!"
    quotes(96)  = "BEEP-BEEP!!  I'm a '49 STUDEBAKER!!"
    quotes(97)  = "Being a BALD HERO is almost as FESTIVE as a TATTOOED KNOCKWURST."
    quotes(98)  = "BELA LUGOSI is my co-pilot.."
    quotes(99)  = "BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-BI-"
    quotes(100) = "...  Blame it on the BOSSA NOVA!!!"
    quotes(101) = "..  bleakness....  desolation....  plastic forks..."
    quotes(102) = "Bo Derek ruined my life!"
    quotes(103) = "Boy, am I glad it's only 1971..."
    quotes(104) = "Boys, you have ALL been selected to LEAVE th' PLANET in 15 minutes!!"
    quotes(105) = "BRILL CREAM is CREAM O' WHEAT in another DIMENSION.."
    quotes(106) = "But was he mature enough last night at the lesbian masquerade?"
    quotes(107) = "By MEER biz doo SCHOIN.."
    quotes(108) = "C'MON, everybody!!  I've flown in LESLIE GORE and two dozen KOSHER BUTCHERS!  They'll be doing intricate MILITARY MANEUVERS to the soundtrack from 'OKLAHOMA'!!"
    quotes(109) = "CALIFORNIA is where people from IOWA or NEW YORK go to subscribe to CABLE TELEVISION!!"
    quotes(110) = "Can I have an IMPULSE ITEM instead?"
    quotes(111) = "Can you MAIL a BEAN CAKE?"
    quotes(112) = "Catsup and Mustard all over the place!  It's the Human Hamburger!"
    quotes(113) = "CHUBBY CHECKER just had a CHICKEN SANDWICH in downtown DULUTH!"
    quotes(114) = "CHUBBY CHECKER owns my BUILDING!"
    quotes(115) = "Civilization is fun!  Anyway, it keeps me busy!!"
    quotes(116) = "Clear the laundromat!!  This whirl-o-matic just had a nuclear meltdown!!"
    quotes(117) = "Concentrate on th'cute, li'l CARTOON GUYS! Remember the SERIAL NUMBERS!!  Follow the WHIPPLE AVE EXIT!! Have a FREE PEPSI!!  Turn LEFT at th'HOLIDAY INN!! JOIN the CREDIT WORLD!!  MAKE me an OFFER!!!"
    quotes(118) = "CONGRATULATIONS!  Now should I make thinly veiled comments about DIGNITY, self-esteem and finding TRUE FUN in your RIGHT VENTRICLE??"
    quotes(119) = "Content:  80% POLYESTER, 20% DACRON..  The waitress's UNIFORM sheds TARTAR SAUCE like an 8'' by 10'' GLOSSY.."
    quotes(120) = "Could I have a drug overdose?"
    quotes(121) = "'DARK SHADOWS' is on!!  Hey, I think the VAMPIRE forgot his UMBRELLA!!"
    quotes(122) = "Darling, my ELBOW is FLYING over FRANKFURT, Germany.."
    quotes(123) = "Dehydrated EGGS are STREWN across ROULETTE TABLES.."
    quotes(124) = "Did an Italian CRANE OPERATOR just experience uninhibited sensations in a MALIBU HOT TUB?"
    quotes(125) = "Did I do an INCORRECT THING??"
    quotes(126) = "Did I say I was a sardine?  Or a bus???"
    quotes(127) = "Did I SELL OUT yet??"
    quotes(128) = "Did we bring enough BEEF JERKY?"
    quotes(129) = "Did YOU find a DIGITAL WATCH in YOUR box of VELVEETA?"
    quotes(130) = "Did you find a DIGITAL WATCH in YOUR box of VELVEETA??"
    quotes(131) = "Did you GAIN WEIGHT in th' past 5 MINUTES or am I just DREAMING of two BROCCOLI FLORETS lying in an empty GAS TANK?"
    quotes(132) = "Did you move a lot of KOREAN STEAK KNIVES this trip, Dingy?"
    quotes(133) = "DIDI...  is that a MARTIAN name, or, are we in ISRAEL?"
    quotes(134) = "Didn't I buy a 1951 Packard from you last March in Cairo?"
    quotes(135) = "Didn't KIRKEGAARD wear out his TIRES in VIENNA during a SNOWSTORM of FREUD's unpaid DENTAL BILLS?"
    quotes(136) = "Disco oil bussing will create a throbbing naugahide pipeline running straight to the tropics from the rug producing regions and devalue the dollar!"
    quotes(137) = "Dizzy, are we 'REAL PEOPLE' or 'AMAZING ANIMALS'?"
    quotes(138) = "Do I have a lifestyle yet?"
    quotes(139) = "Do I hear th' SPINNING of various WHIRRING, ROUND, and WARM WHIRLOMATICS?!"
    quotes(140) = "Do you guys know we just passed thru a BLACK HOLE in space?"
    quotes(141) = "Do you have exactly what I want in a plaid poindexter bar bat??"
    quotes(142) = "..  Do you like ``TENDER VITTLES?''?"
    quotes(143) = "Do you need any MOUTH-TO-MOUTH resuscitation?"
    quotes(144) = "Do you think the ``Monkees'' should get gas on odd or even days?"
    quotes(145) = "Does someone from PEORIA have a SHORTER ATTENTION span than me?"
    quotes(146) = "Does that mean I'm not a well-adjusted person??"
    quotes(147) = "..  does your DRESSING ROOM have enough ASPARAGUS?"
    quotes(148) = "DON'T go!!  I'm not HOWARD COSELL!!  I know POLISH JOKES...  WAIT!! Don't go!!  I AM Howard Cosell!...  And I DON'T know Polish jokes!!"
    quotes(149) = "Don't hit me!!  I'm in the Twilight Zone!!!"
    quotes(150) = "Don't SANFORIZE me!!"
    quotes(151) = "Don't worry, nobody really LISTENS to lectures in MOSCOW, either! ..  FRENCH, HISTORY, ADVANCED CALCULUS, COMPUTER PROGRAMMING, BLACK STUDIES, SOCIOBIOLOGY!..  Are there any QUESTIONS??"
    quotes(152) = "Edwin Meese made me wear CORDOVANS!!"
    quotes(153) = "Eisenhower!!  Your mimeograph machine upsets my stomach!!"
    quotes(154) = "Either CONFESS now or we go to ``PEOPLE'S COURT''!!"
    quotes(155) = "Everybody gets free BORSCHT!"
    quotes(156) = "Everybody is going somewhere!!  It's probably a garage sale or a disaster Movie!!"
    quotes(157) = "..Everything is....FLIPPING AROUND!!"
    quotes(158) = "Everything will be ALL RIGHT if we can just remember things about ALGEBRA.. or SOCCER..  or SOCIALISM.."
    quotes(159) = "Everywhere I look I see NEGATIVITY and ASPHALT..."
    quotes(160) = "Excuse me, but didn't I tell you there's NO HOPE for the survival of OFFSET PRINTING?"
    quotes(161) = "FEELINGS are cascading over me!!!"
    quotes(162) = "Fell th' WHIRLING BUFFERS buffing away all that stress... Years of ROAD TAR gently washing away..."
    quotes(163) = "Finally, Zippy drives his 1958 RAMBLER METROPOLITAN into the faculty dining room."
    quotes(164) = "FIRST, I was in a TRUCK...THEN, I was in a DINER..."
    quotes(165) = "FIRST, I'm covering you with OLIVE OIL and PRUNE WHIP!!"
    quotes(166) = "First, I'm going to give you all the ANSWERS to today's test.. So just plug in your SONY WALKMANS and relax!!"
    quotes(167) = "FISH-NET-FISH-NET-FISH-NET-FISH-NET-FISH!!"
    quotes(168) = "Fold, fold, FOLD!!  FOLDING many items!!"
    quotes(169) = "FOOLED you!  Absorb EGO SHATTERING impulse rays, polyester poltroon!!"
    quotes(170) = "Four thousand different MAGNATES, MOGULS & NABOBS are romping in my gothic solarium!!"
    quotes(171) = "FROZEN ENTREES may be flung by members of opposing SWANSON SECTS.."
    quotes(172) = "FUN is never having to say you're SUSHI!!"
    quotes(173) = "Gee, I feel kind of LIGHT in the head now, knowing I can't make my satellite dish PAYMENTS!"
    quotes(174) = "...Get me a GIN and TONIC!!...make it HAIR TONIC!!"
    quotes(175) = "Gibble, Gobble, we ACCEPT YOU ---"
    quotes(176) = "Give them RADAR-GUIDED SKEE-BALL LANES and VELVEETA BURRITOS!!"
    quotes(177) = "Go on, EMOTE!  I was RAISED on thought balloons!!"
    quotes(178) = "GOOD-NIGHT, everybody..  Now I have to go administer FIRST-AID to my pet LEISURE SUIT!!"
    quotes(179) = "Ha ha   Ha ha  Ha ha   Ha  Ha  Ha  Ha  -- When will I EVER stop HAVING FUN?!!"
    quotes(180) = "HAIR TONICS, please!!"
    quotes(181) = "Half a mind is a terrible thing to waste!"
    quotes(182) = "Hand me a pair of leather pants and a CASIO keyboard -- I'm living for today!"
    quotes(183) = "Has everybody got HALVAH spread all over their ANKLES??... Now, it's time to ``HAVE A NAGEELA''!!"
    quotes(184) = "Have my two-tone, 1958 Nash METRO brought around.."
    quotes(185) = "..  he dominates the DECADENT SUBWAY SCENE."
    quotes(186) = "He is the MELBA-BEING...  the ANGEL CAKE...  XEROX him...  XEROX him --"
    quotes(187) = "He probably just wants to take over my CELLS and then EXPLODE inside me like a BARREL of runny CHOPPED LIVER!  Or maybe he'd like to PSYCHOLOGICALLY TERRORIZE ME until I have no objection to a RIGHT-WING MILITARY TAKEOVER of my apartment!!  I guess I should call AL PACINO!"
    quotes(188) = "HELLO KITTY gang terrorizes town, family STICKERED to death!"
    quotes(189) = "HELLO, everybody, I'm a HUMAN!!"
    quotes(190) = "Hello, GORRY-O!!  I'm a GENIUS from HARVARD!!"
    quotes(191) = "HELLO, little boys!   Gimme a MINT TULIP!!  Let's do the BOSSA NOVA!!"
    quotes(192) = "--Hello, POLICE?  I've got ABBOTT & COSTELLO here on suspicion of HIGHWAY ROBBERY!!"
    quotes(193) = "Hello.  I know the divorce rate among unmarried Catholic Alaskan females!!"
    quotes(194) = "Hello.  Just walk along and try NOT to think about your INTESTINES being almost FORTY YARDS LONG!!"
    quotes(195) = "Hello...  IRON CURTAIN?  Send over a SAUSAGE PIZZA! World War III?  No thanks!"
    quotes(196) = "Hello?  Enema Bondage?  I'm calling because I want to be happy, I guess.."
    quotes(197) = "Here I am at the flea market but nobody is buying my urine sample bottles.."
    quotes(198) = "..  here I am in 53 B.C. and all I want is a dill pickle!!"
    quotes(199) = "Here I am in the POSTERIOR OLFACTORY LOBULE but I don't see CARL SAGAN anywhere!!"
    quotes(200) = "Here is my refrigerator full of FLANK STEAK...and over there is my UPHOLSTERED CANOE...I don't know WHY I OWN them!!"
    quotes(201) = "Here we are in America...  when do we collect unemployment?"
    quotes(202) = "HERE!!  Put THIS on!!  I'm in CHARGE!!"
    quotes(203) = "Hey!!  Let's watch the' ELEVATOR go UP and DOWN at th' HILTON HOTEL!!"
    quotes(204) = "Hey, I LIKE that POINT!!"
    quotes(205) = "Hey, LOOK!!  A pair of SIZE 9 CAPRI PANTS!!  They probably belong to SAMMY DAVIS, JR.!!"
    quotes(206) = "Hey, wait a minute!!  I want a divorce!!..  you're not Clint Eastwood!!"
    quotes(207) = "Hey, waiter!  I want a NEW SHIRT and a PONY TAIL with lemon sauce!"
    quotes(208) = "Hiccuping & trembling into the WASTE DUMPS of New Jersey like some drunken CABBAGE PATCH DOLL, coughing in line at FIORUCCI'S!!"
    quotes(209) = "Hmmm..  a CRIPPLED ACCOUNTANT with a FALAFEL sandwich is HIT by a TROLLEY-CAR.."
    quotes(210) = "Hmmm..  A hash-singer and a cross-eyed guy were SLEEPING on a deserted  island, when..."
    quotes(211) = "Hmmm...  a PINHEAD, during an EARTHQUAKE, encounters an ALL-MIDGET FIDDLE ORCHESTRA...  ha..  ha.."
    quotes(212) = "Hmmm...  an arrogant bouquet with a subtle suggestion of POLYVINYL CHLORIDE..."
    quotes(213) = "Hold the MAYO & pass the COSMIC AWARENESS..."
    quotes(214) = "HOORAY, Ronald!!  Now YOU can marry LINDA RONSTADT too!!"
    quotes(215) = "HOW could a GLASS be YELLING??"
    quotes(216) = "How do I get HOME?"
    quotes(217) = "How do you explain Wayne Newton's POWER over millions? It's th' MOUSTACHE...  Have you ever noticed th' way it radiates SINCERITY, HONESTY & WARMTH?  It's a MOUSTACHE you want to take HOME and introduce to NANCY SINATRA!"
    quotes(218) = "How many retired bricklayers from FLORIDA are out purchasing PENCIL SHARPENERS right NOW??"
    quotes(219) = "How's it going in those MODULAR LOVE UNITS??"
    quotes(220) = "How's the wife?  Is she at home enjoying capitalism?"
    quotes(221) = "..  hubub, hubub, HUBUB, hubub, hubub, hubub, HUBUB, hubub, hubub, hubub."
    quotes(222) = "HUGH BEAUMONT died in 1982!!"
    quotes(223) = "HUMAN REPLICAS are inserted into VATS of NUTRITIONAL YEAST..."
    quotes(224) = "Hydraulic pizza oven!!  Guided missile!  Herring sandwich!  Styrofoam! Jayne Mansfield!  Aluminum siding!  Borax!  Pedal pushers!  Jukebox!"
    quotes(225) = "I always have fun because I'm out of my mind!!!"
    quotes(226) = "I always liked FLAG DAY!!"
    quotes(227) = "I always wanted a NOSE JOB!!"
    quotes(228) = "I am a jelly donut.  I am a jelly donut."
    quotes(229) = "I am a traffic light, and Alan Ginzberg kidnapped my laundry in 1927!"
    quotes(230) = "I am covered with pure vegetable oil and I am writing a best seller!"
    quotes(231) = "I am deeply CONCERNED and I want something GOOD for BREAKFAST!"
    quotes(232) = "I am having a CONCEPTION--"
    quotes(233) = "I am having a pleasant time!!"
    quotes(234) = "I am having FUN...  I wonder if it's NET FUN or GROSS FUN?"
    quotes(235) = "I am KING BOMBA of Sicily!..I will marry LUCILLE BALL next Friday!"
    quotes(236) = "I am NOT a nut...."
    quotes(237) = "I appoint you ambassador to Fantasy Island!!!"
    quotes(238) = "I brought my BOWLING BALL - and some DRUGS!!"
    quotes(239) = "I call it a 'SARDINE ON WHEAT'!"
    quotes(240) = "-- I can do ANYTHING ... I can even ... SHOPLIFT!!"
    quotes(241) = "I can see you GUYS an' GALS need a LOT of HELP...You're all very STUPID!!  I used to be STUPID, too..before I started watching UHF-TV!!"
    quotes(242) = "I can't decide which WRONG TURN to make first!! I wonder if BOB GUCCIONE has these problems!"
    quotes(243) = "I can't think about that.  It doesn't go with HEDGES in the shape of LITTLE LULU -- or ROBOTS making BRICKS..."
    quotes(244) = "I decided to be JOHN TRAVOLTA instead!!"
    quotes(245) = "I demand IMPUNITY!"
    quotes(246) = "I didn't order any WOO-WOO...  Maybe a YUBBA..  But no WOO-WOO!"
    quotes(247) = "I don't believe there really IS a GAS SHORTAGE..  I think it's all just a BIG HOAX on the part of the plastic sign salesmen-- ..  to sell more numbers!!"
    quotes(248) = "..  I don't know why but, suddenly, I want to discuss declining I.Q. LEVELS with a blue ribbon SENATE SUB-COMMITTEE!"
    quotes(249) = "I don't know WHY I said that..  I think it came from the FILLINGS in my rear molars.."
    quotes(250) = "I don't think you fellows would do so much RAPING and PILLAGING if you played more PINBALL and watched CABLE TELEVISION!!"
    quotes(251) = "..  I don't understand the HUMOR of the THREE STOOGES!!"
    quotes(252) = "I feel better about world problems now!"
    quotes(253) = "I feel like a wet parking meter on Darvon!"
    quotes(254) = "I feel like I am sharing a ``CORN-DOG'' with NIKITA KHRUSCHEV.."
    quotes(255) = "I feel like I'm in a Toilet Bowl with a thumbtack in my forehead!!"
    quotes(256) = "I feel partially hydrogenated!"
    quotes(257) = "I feel real SOPHISTICATED being in FRANCE!"
    quotes(258) = "..  I feel..  JUGULAR.."
    quotes(259) = "I fill MY industrial waste containers with old copies of the ``WATCHTOWER'' and then add HAWAIIAN PUNCH to the top..  They look NICE in the yard--"
    quotes(260) = "I FORGOT to do the DISHES!!"
    quotes(261) = "I guess it was all a DREAM..  or an episode of HAWAII FIVE-O..."
    quotes(262) = "I guess we can live on his POT FARM in HADES!!"
    quotes(263) = "I guess you guys got BIG MUSCLES from doing too much STUDYING!"
    quotes(264) = "I had a lease on an OEDIPUS COMPLEX back in '81..."
    quotes(265) = "I had pancake makeup for brunch!"
    quotes(266) = "I have a TINY BOWL in my HEAD"
    quotes(267) = "I HAVE a towel."
    quotes(268) = "I have a very good DENTAL PLAN.  Thank you."
    quotes(269) = "..  I have a VISION!  It's a RANCID double-FISHWICH on an ENRICHED BUN!!"
    quotes(270) = "I have accepted Provolone into my life!"
    quotes(271) = "I have many CHARTS and DIAGRAMS.."
    quotes(272) = "I have no actual hairline..."
    quotes(273) = "I have nostalgia for the late Sixties!  In 1969 I left my laundry with a hippie!!  During an unauthorized tupperware party it was chopped & diced!"
    quotes(274) = "--- I have seen the FUN ---"
    quotes(275) = "I have seen these EGG EXTENDERS in my Supermarket.. ..  I have read the INSTRUCTIONS..."
    quotes(276) = "I have the power to HALT PRODUCTION on all TEENAGE SEX COMEDIES!!"
    quotes(277) = "I HAVE to buy a new ``DODGE MISER'' and two dozen JORDACHE JEANS because my viewscreen is ``USER-FRIENDLY''!!"
    quotes(278) = "I haven't been married in over six years, but we had sexual counseling every day from Oral Roberts!!"
    quotes(279) = "I HIJACKED a 747 to get here!!  I hope those fabulous CONEHEADS are at HOME!!"
    quotes(280) = "I hope I bought the right relish...  zzzzzzzzz..."
    quotes(281) = "I hope something GOOD came in the mail today so I have a REASON to live!!"
    quotes(282) = "I hope the ``Eurythmics'' practice birth control..."
    quotes(283) = "I hope you millionaires are having fun!  I just invested half your life savings in yeast!!"
    quotes(284) = "I invented skydiving in 1989!"
    quotes(285) = "I joined scientology at a garage sale!!"
    quotes(286) = "I just bought FLATBUSH from MICKEY MANTLE!"
    quotes(287) = "I just forgot my whole philosophy of life!!!"
    quotes(288) = "I just got my PRINCE bumper sticker.. But now I can't remember WHO he is..."
    quotes(289) = "I just had a MAJOR CONTRACT DISPUTE with SUZANNE SOMERS!!"
    quotes(290) = "I just had a NOSE JOB!!"
    quotes(291) = "I just had my entire INTESTINAL TRACT coated with TEFLON!"
    quotes(292) = "I just heard the SEVENTIES were over!!  And I was just getting in touch with my LEISURE SUIT!!"
    quotes(293) = "I just put lots of the EGG SALAD in the SILK SOCKS --"
    quotes(294) = "I just remembered something about a TOAD!"
    quotes(295) = "..I just walked into th' HOUSE OF REPRESENTATIVES with fourteen WET DOLPHINS and an out-of-date MARRIAGE MANUAL..."
    quotes(296) = "I KAISER ROLL?!  What good is a Kaiser Roll without a little COLE SLAW on the SIDE?"
    quotes(297) = "I Know A Joke"
    quotes(298) = "I know how to do SPECIAL EFFECTS!!"
    quotes(299) = "I know how to get the hostesses released!  Give them their own television series!"
    quotes(300) = "I know th'MAMBO!!  I have a TWO-TONE CHEMISTRY SET!!"
    quotes(301) = "I know things about TROY DONAHUE that can't even be PRINTED!!"
    quotes(302) = "I left my WALLET in the BATHROOM!!"
    quotes(303) = "I LIKE Aisle 7a."
    quotes(304) = "I like the IMPUDENT NOSE on that car..  Are you a TEEN-AGER?  "
    quotes(305) = "I like the way ONLY their mouths move..  They look like DYING OYSTERS"
    quotes(306) = "I like your SNOOPY POSTER!!"
    quotes(307) = "... I live in a FUR-LINE FALLOUT SHELTER"
    quotes(308) = "I love FRUIT PICKERS!!"
    quotes(309) = "--``I love KATRINKA because she drives a PONTIAC.  We're going away now.  I fed the cat. - Zippy''"
    quotes(310) = "I love ROCK 'N ROLL!  I memorized the all WORDS to ``WIPE-OUT'' in 1965!!"
    quotes(311) = "..I must be a VETERINARIAN.."
    quotes(312) = "I need 'RONDO'."
    quotes(313) = "I need to discuss BUY-BACK PROVISIONS with at least six studio SLEAZEBALLS!!"
    quotes(314) = "I once decorated my apartment entirely in ten foot salad forks!!"
    quotes(315) = "I own seven-eighths of all the artists in downtown Burbank!"
    quotes(316) = "I OWN six pink HIPPOS!!"
    quotes(317) = "I predict that by 1993 everyone will live in and around LAS VEGAS and wear BEATLE HAIRCUTS!"
    quotes(318) = "I pretend I'm living in a styrofoam packing crate, high in th' SWISS ALPS, still unable to accept th' idea of TOUCH-TONE DIALING!!"
    quotes(319) = "I put aside my copy of ``BOWLING WORLD'' and think about GUN CONTROL legislation.."
    quotes(320) = "I represent a sardine!!"
    quotes(321) = "I request a weekend in Havana with Phil Silvers!"
    quotes(322) = "..  I see TOILET SEATS..."
    quotes(323) = "I selected E5...  but I didn't hear ``Sam the Sham and the Pharaohs''!"
    quotes(324) = "I smell a RANCID CORN DOG!"
    quotes(325) = "I smell like a wet reducing clinic on Columbus Day!"
    quotes(326) = "I think I am an overnight sensation right now!!"
    quotes(327) = "..  I think I'd better go back to my DESK and toy with a few common MISAPPREHENSIONS..."
    quotes(328) = "I think I'll do BOTH if I can get RESIDUALS!!"
    quotes(329) = "..  I think I'll KILL myself by leaping out of this 14th STOREY WINDOW while reading ERICA JONG'S poetry!!"
    quotes(330) = "I think I'll make SCRAMBLED EGGS!!  They're each in LITTLE SHELLS.."
    quotes(331) = "...I think I'm having an overnight sensation right now!!"
    quotes(332) = "I think my career is ruined!"
    quotes(333) = "I think my CAREER is RUINED!!"
    quotes(334) = "I used to be a FUNDAMENTALIST, but then I heard about the HIGH RADIATION LEVELS and bought an ENCYCLOPEDIA!!"
    quotes(335) = "..  I want a COLOR T.V. and a VIBRATING BED!!!"
    quotes(336) = "I want a VEGETARIAN BURRITO to go..  with EXTRA MSG!!"
    quotes(337) = "I want a WESSON OIL lease!!"
    quotes(338) = "I want another RE-WRITE on my CAESAR SALAD!!"
    quotes(339) = "I want DUSTIN HOFFMAN!! .. I want LIBRACE!!  YOW!!"
    quotes(340) = "I want EARS!  I want two ROUND BLACK EARS to make me feel warm 'n secure!!"
    quotes(341) = "..  I want FORTY-TWO TRYNEL FLOATATION SYSTEMS installed within SIX AND A HALF HOURS!!!"
    quotes(342) = "I want the presidency so bad I can already taste the hors d'oeuvres."
    quotes(343) = "I want to dress you up as TALLULAH BANKHEAD and cover you with VASELINE and WHEAT THINS.."
    quotes(344) = "I want to kill everyone here with a cute colorful Hydrogen Bomb!!"
    quotes(345) = "..  I want to perform cranial activities with Tuesday Weld!!"
    quotes(346) = "I want to read my new poem about pork brains and outer space..."
    quotes(347) = "I want to so HAPPY, the VEINS in my neck STAND OUT!!"
    quotes(348) = "I want to TAKE IT HOME and DRESS IT UP in HOT PANTS!!"
    quotes(349) = "I want you to MEMORIZE the collected poems of EDNA ST VINCENT MILLAY.. BACKWARDS!!"
    quotes(350) = "I want you to organize my PASTRY trays...  my TEA-TINS are gleaming in formation like a ROW of DRUM MAJORETTES -- please don't be FURIOUS with me --"
    quotes(351) = "I was born in a Hostess Cupcake factory before the sexual revolution!"
    quotes(352) = "I was giving HAIR CUTS to th' SAUCER PEOPLE ..  I'm CLEAN!!"
    quotes(353) = "I was in a HOT TUB!  I was NORMAL!  I was ITALIAN!!  I enjoyed th' EARTHQUAKE!"
    quotes(354) = "I was in EXCRUCIATING PAIN until I started reading JACK AND JILL Magazine!!"
    quotes(355) = "I was making donuts and now I'm on a bus!"
    quotes(356) = "I will establish the first SHOPPING MALL in NUTLEY, New Jersey..."
    quotes(357) = "I will invent 'TIDY BOWL'..."
    quotes(358) = "I will SHAVE and buy JELL-O and bring my MARRIAGE MANUAL!!"
    quotes(359) = "I wish I was a sex-starved manicurist found dead in the Bronx!!"
    quotes(360) = "I wish I was on a Cincinnati street corner holding a clean dog!"
    quotes(361) = "I wonder if I could ever get started in the credit world?"
    quotes(362) = "..  I wonder if I ought to tell them about my PREVIOUS LIFE as a COMPLETE STRANGER?"
    quotes(363) = "I wonder if I should put myself in ESCROW!!"
    quotes(364) = "I wonder if there's anything GOOD on tonight?"
    quotes(365) = "I would like to urinate in an OVULAR, porcelain pool --"
    quotes(366) = "I'd like MY data-base JULIENNED and stir-fried!"
    quotes(367) = "I'd like some JUNK FOOD...  and then I want to be ALONE --"
    quotes(368) = "I'd like TRAINED SEALS and a CONVERTIBLE on my doorstep by NOON!!"
    quotes(369) = "I'll clean your ROOM!!  I know some GOOD stories, too!!  All about ROAD Island's, HUSH Puppies, and how LUKE finds GOLD on his LAND!!"
    quotes(370) = "I'll eat ANYTHING that's BRIGHT BLUE!!"
    quotes(371) = "I'LL get it!!  It's probably a FEW of my ITALIAN GIRL-FRIENDS!!"
    quotes(372) = "..I'll make you an ASHTRAY!!"
    quotes(373) = "I'll show you MY telex number if you show me YOURS..."
    quotes(374) = "I'll take ROAST BEEF if you're out of LAMB!!"
    quotes(375) = "I'm a fuschia bowling ball somewhere in Brittany"
    quotes(376) = "I'm a GENIUS!  I want to dispute sentence structure with SUSAN SONTAG!!"
    quotes(377) = "I'm a nuclear submarine under the polar ice cap and I need a Kleenex!"
    quotes(378) = "I'm also against BODY-SURFING!!"
    quotes(379) = "I'm also pre-POURED pre-MEDITATED and pre-RAPHAELITE!!"
    quotes(380) = "I'm an East Side TYPE.."
    quotes(381) = "I'm ANN LANDERS!!  I can SHOPLIFT!!"
    quotes(382) = "I'm ANN LANDERS!!  I can SHOPLIFT!!"
    quotes(383) = "I'm changing the CHANNEL..  But all I get is commercials for ``RONCO MIRACLE BAMBOO STEAMERS''!"
    quotes(384) = "I'm continually AMAZED at th'breathtaking effects of WIND EROSION!!"
    quotes(385) = "I'm CONTROLLED by the CIA!!  EVERYONE is controlled by the CIA!!"
    quotes(386) = "I'm definitely not in Omaha!"
    quotes(387) = "I'm DESPONDENT...  I hope there's something DEEP-FRIED under this miniature DOMED STADIUM..."
    quotes(388) = "I'm dressing up in an ill-fitting IVY-LEAGUE SUIT!!  Too late..."
    quotes(389) = "I'm EMOTIONAL now because I have MERCHANDISING CLOUT!!"
    quotes(390) = "I'm encased in the lining of a pure pork sausage!!"
    quotes(391) = "I'm EXCITED!!  I want a FLANK STEAK WEEK-END!!  I think I'm JULIA CHILD!!"
    quotes(392) = "I'm GLAD I remembered to XEROX all my UNDERSHIRTS!!"
    quotes(393) = "I'm gliding over a NUCLEAR WASTE DUMP near ATLANTA, Georgia!!"
    quotes(394) = "I'm having a BIG BANG THEORY!!"
    quotes(395) = "I'm having a MID-WEEK CRISIS!"
    quotes(396) = "I'm having a RELIGIOUS EXPERIENCE..  and I don't take any DRUGS"
    quotes(397) = "I'm having a tax-deductible experience!  I need an energy crunch!!"
    quotes(398) = "I'm having an emotional outburst!!"
    quotes(399) = "I'm having an EMOTIONAL OUTBURST!!  But, uh, WHY is there a WAFFLE in my PAJAMA POCKET??"
    quotes(400) = "I'm having BEAUTIFUL THOUGHTS about the INSIPID WIVES of smug and wealthy CORPORATE LAWYERS.."
    quotes(401) = "I'm having fun HITCHHIKING to CINCINNATI or FAR ROCKAWAY!!"
    quotes(402) = "..  I'm IMAGINING a sensuous GIRAFFE, CAVORTING in the BACK ROOM of a KOSHER DELI --"
    quotes(403) = "I'm in a twist contest!!  I'm in a bathtub!  It's on Mars!!  I'm in tip-top condition!"
    quotes(404) = "I'm in ATLANTIC CITY riding in a comfortable ROLLING CHAIR..."
    quotes(405) = "I'm in direct contact with many advanced fun CONCEPTS."
    quotes(406) = "I'm in DISGUISE as a BAGGAGE CHECKER....I can watch the house, if it's ORANGE..."
    quotes(407) = "I'm in LOVE with DON KNOTTS!!"
    quotes(408) = "I'm into SOFTWARE!"
    quotes(409) = "I'm losing my hair..did it go to ATLANTIC CITY??"
    quotes(410) = "I'm meditating on the FORMALDEHYDE and the ASBESTOS leaking into my PERSONAL SPACE!!"
    quotes(411) = "I'm MENTALLY here..  but PHYSICALLY I'm purchasing NAUGAHYDE furniture in the' SUBURBS of PHOENIX!!"
    quotes(412) = "I'm mentally OVERDRAWN!  What's that SIGNPOST up ahead? Where's ROD STERLING when you really need him?"
    quotes(413) = "I'm not an Iranian!!  I voted for Dianne Feinstein!!"
    quotes(414) = "I'm not available for comment.."
    quotes(415) = "I'm pretending I'm pulling in a TROUT!  Am I doing it correctly??"
    quotes(416) = "I'm pretending that we're all watching PHIL SILVERS instead of RICARDO MONTALBAN!"
    quotes(417) = "I'm protected by a ROLL-ON I rented from AVIS.."
    quotes(418) = "I'm QUIETLY reading the latest issue of ``BOWLING WORLD'' while my wife and two children stand QUIETLY BY.."
    quotes(419) = "I'm rated PG-34!!"
    quotes(420) = "I'm receiving a coded message from EUBIE BLAKE!!"
    quotes(421) = "I'm RELIGIOUS!!  I love a man with a HAIRPIECE!! Equip me with MISSILES!!"
    quotes(422) = "I'm reporting for duty as a modern person.  I want to do the Latin Hustle now!"
    quotes(423) = "I'm shaving!!  I'M SHAVING!!"
    quotes(424) = "I'm sitting on my SPEED QUEEN..  To me, it's ENJOYABLE.. I'm WARM..  I'm VIBRATORY.."
    quotes(425) = "I'm thinking about DIGITAL READ-OUT systems and computer-generated IMAGE FORMATIONS.."
    quotes(426) = "I'm totally DESPONDENT over the LIBYAN situation and the price of CHICKEN.."
    quotes(427) = "I'm using my X-RAY VISION to obtain a rare glimpse of the INNER WORKINGS of this POTATO!!"
    quotes(428) = "I'm wearing PAMPERS!!"
    quotes(429) = "I'm wet!  I'm wild!"
    quotes(430) = "I'm working under the direct orders of WAYNE NEWTON to deport consenting adults!"
    quotes(431) = "I'm young..  I'm HEALTHY..  I can HIKE THRU CAPT GROGAN'S LUMBAR REGIONS!"
    quotes(432) = "I'm ZIPPY the PINHEAD and I'm totally committed to the festive mode."
    quotes(433) = "I'm ZIPPY!!  Are we having FUN yet??"
    quotes(434) = "I've been WRITING to SOPHIA LOREN every 45 MINUTES since JANUARY 1ST!!"
    quotes(435) = "I've got a COUSIN who works in the GARMENT DISTRICT..."
    quotes(436) = "I've got an IDEA!!  Why don't I STARE at you so HARD, you forget your SOCIAL SECURITY NUMBER!!"
    quotes(437) = "I've got to get these SNACK CAKES to NEWARK by DAWN!!"
    quotes(438) = "I've gotta GO, now!!  I wanta tell you you're a GREAT bunch of guys but you ought to CHANGE your UNDERWEAR more often!!"
    quotes(439) = "I've read SEVEN MILLION books!!"
    quotes(440) = "..  ich bin in einem dusenjet ins jahr 53 vor chr... ich lande im antiken Rom...  einige gladiatoren spielen scrabble... ich rieche PIZZA..."
    quotes(441) = "If a person is FAMOUS in this country, they have to go on the ROAD for MONTHS at a time and have their name misspelled on the SIDE of a GREYHOUND SCENICRUISER!!"
    quotes(442) = "If elected, Zippy pledges to each and every American a 55-year-old houseboy..."
    quotes(443) = "If I am elected no one will ever have to do their laundry again!"
    quotes(444) = "If I am elected, the concrete barriers around the WHITE HOUSE will be replaced by tasteful foam replicas of ANN MARGARET!"
    quotes(445) = ".. If I cover this entire WALL with MAZOLA, wdo I have to give my AGENT ten per cent??"
    quotes(446) = "If I felt any more SOPHISTICATED I would DIE of EMBARRASSMENT!"
    quotes(447) = "If I had a Q-TIP, I could prevent th'collapse of NEGOTIATIONS!!"
    quotes(448) = "..  If I had heart failure right now, I couldn't be a more fortunate man!!"
    quotes(449) = "If I have enough money to buy 5,000 CANS of NOODLE-RONI, can I get a VAT of MARSHMALLOW FLUFF free??"
    quotes(450) = "If I pull this SWITCH I'll be RITA HAYWORTH!!  Or a SCIENTOLOGIST!"
    quotes(451) = "- if it GLISTENS, gobble it!!"
    quotes(452) = "If our behavior is strict, we do not need fun!"
    quotes(453) = "If Robert Di Niro assassinates Walter Slezak, will Jodie Foster marry Bonzo??"
    quotes(454) = "If this is the DATING GAME I want to know your FAVORITE PLANET!  Do I get th' MICROWAVE MOPED?"
    quotes(455) = "If this was a SWEDISH MOVIE, I'd take off your GO-GO BOOTS!!"
    quotes(456) = "If you STAY in China, I'll give you 4,000 BUSHELS of 'ATOMIC MOUSE' pencil sharpeners!!"
    quotes(457) = "Imagine--a WORLD without POODLES..."
    quotes(458) = "Impudent..  Yet possessing a certain ALUMINUM SILICATE overbite....Needs REDDY-WHIP!!"
    quotes(459) = "-- In 1962, you could buy a pair of SHARKSKIN SLACKS, with a ``Continental Belt,'' for $10.99!!"
    quotes(460) = "In Newark the laundromats are open 24 hours a day!"
    quotes(461) = "In order to make PLANS for the WEEKEND...so that we can read RESTAURANT REVIEWS and decide to GO to that restaurant & then NEVER GO...so we can meet a FRIEND after work in a BAR and COMPLAIN about Interior Sect'y JAMES WATT until the SUBJECT is changed to NUCLEAR BLACKMAIL...and so our RELATIVES can FORCE us to listen to HOCKEY STATISTICS while we wait for them to LEAVE on the 7:48...."
    quotes(462) = "INSIDE, I have the same personality disorder as LUCY RICARDO!!"
    quotes(463) = "Inside, I'm already SOBBING!"
    quotes(464) = "Intra-mural sports results are filtering through th' plumbing..."
    quotes(465) = "Is a tattoo real, like a curb or a battleship? Or are we suffering in Safeway?"
    quotes(466) = "Is it 1974?  What's for SUPPER?  Can I spend my COLLEGE FUND in one wild afternoon??"
    quotes(467) = "Is it clean in other dimensions?"
    quotes(468) = "Is it FUN to be a MIDGET?"
    quotes(469) = "Is it NOUVELLE CUISINE when 3 olives are struggling with a scallop in a plate of SAUCE MORNAY?"
    quotes(470) = "Is something VIOLENT going to happen to a GARBAGE CAN?"
    quotes(471) = "Is the EIGHTIES when they had ART DECO and GERALD McBOING-BOING lunch boxes??"
    quotes(472) = "Is there something I should be DOING with a GLAZED DONUT??"
    quotes(473) = "Is this 'BIKINI BEACH'?"
    quotes(474) = "Is this 'BOOZE'?"
    quotes(475) = "Is this an out-take from the ``BRADY BUNCH''?"
    quotes(476) = "Is this ANYWHERE, USA?"
    quotes(477) = "Is this BOISE??"
    quotes(478) = "Is this going to involve RAW human ecstasy?"
    quotes(479) = "Is this my STOP??"
    quotes(480) = "Is this TERMINAL fun?"
    quotes(481) = "Is this the line for the latest whimsical  YUGOSLAVIAN drama which also makes you want to CRY and reconsider the VIETNAM WAR?"
    quotes(482) = "Is this where people are HOT and NICE and they give you TOAST for FREE??"
    quotes(483) = "Isn't this my STOP?!"
    quotes(484) = "It don't mean a THING if you ain't got that SWING!!"
    quotes(485) = "It was a JOKE!!  Get it??  I was receiving messages from DAVID LETTERMAN!!  YOW!!"
    quotes(486) = "It's 74 degrees, 12 minutes NORTH, and 41 degrees, 3 minutes EAST!! Soon, it will be TUESDAY!!"
    quotes(487) = "It's a lot of fun being alive...  I wonder if my bed is made?!?"
    quotes(488) = "It's hard being an ARTIST!!"
    quotes(489) = "It's NO USE..  I've gone to ``CLUB MED''!!"
    quotes(490) = "It's OBVIOUS..  The FURS never reached ISTANBUL..  You were an EXTRA in the REMAKE of ``TOPKAPI''..  Go home to your WIFE..  She's making FRENCH TOAST!"
    quotes(491) = "It's OKAY --- I'm an INTELLECTUAL, too."
    quotes(492) = "...It's REAL ROUND..  And it's got a POINTY PART right in the MIDDLE!! The shape is SMOOTH..  ..And COLD.. It feels very COMFORTABLE on my CHEEK..  I'm getting EMOTIONAL.."
    quotes(493) = "It's so OBVIOUS!!"
    quotes(494) = "It's strange, but I'm only TRULY ALIVE when I'm covered in POLKA DOTS and TACO SAUCE..."
    quotes(495) = "It's the land of DONNY AND MARIE as promised in TV GUIDE!"
    quotes(496) = "It's the RINSE CYCLE!!  They've ALL IGNORED the RINSE CYCLE!!"
    quotes(497) = "It's today's SPECIAL!"
    quotes(498) = "JAPAN is a WONDERFUL planet -- I wonder if we'll ever reach their level of COMPARATIVE SHOPPING..."
    quotes(499) = "Jesus is my POSTMASTER GENERAL.."
    quotes(500) = "Join the PLUMBER'S UNION!!"
    quotes(501) = "...Just enough time to do my LIBERACE impression..."
    quotes(502) = "Just imagine you're entering a state-of-the-art CAR WASH!!"
    quotes(503) = "Just to have MORE FUN, I'll pretend I am JAMES CAGNEY and I am having a tense, UP-TIGHT EXPERIENCE!!"
    quotes(504) = "KARL MALDEN'S NOSE just won an ACADEMY AWARD!!"
    quotes(505) = "Kids, don't gross me off..  ``Adventures with MENTAL HYGIENE'' can be carried too FAR!"
    quotes(506) = "Kids, the seven basic food groups are GUM, PUFF PASTRY, PIZZA, PESTICIDES, ANTIBIOTICS, NUTRA-SWEET and MILK DUDS!!"
    quotes(507) = "Laundry is the fifth dimension!!  ...um...um...  th' washing machine is a black hole and the pink socks are bus drivers who just fell in!!"
    quotes(508) = "LBJ, LBJ, how many JOKES did you tell today??!"
    quotes(509) = "Leona, I want to CONFESS things to you.. I want to WRAP you in a SCARLET ROBE trimmed with POLYVINYL CHLORIDE.. I want to EMPTY your ASHTRAYS..."
    quotes(510) = "Let me do my TRIBUTE to FISHNET STOCKINGS..."
    quotes(511) = "Let's all show human CONCERN for REVEREND MOON's legal difficulties!!"
    quotes(512) = "Let's climb to the TOP of that MOUNTAIN and think about STRIP MINING!!"
    quotes(513) = "Let's go to CHURCH!"
    quotes(514) = "Let's send the Russians defective lifestyle accessories!"
    quotes(515) = "LIFE is a never-ending INFORMERCIAL!"
    quotes(516) = "Life is a POPULARITY CONTEST!  I'm REFRESHINGLY CANDID!!"
    quotes(517) = "Life is selling REVOLUTIONARY HAIR PRODUCTS!"
    quotes(518) = "..  Like I always say -- nothing can beat the BRATWURST here in DUSSELDORF!!"
    quotes(519) = "Loni Anderson's hair should be LEGALIZED!!"
    quotes(520) = "Look DEEP into the OPENINGS!!  Do you see any ELVES or EDSELS... or a HIGHBALL??..."
    quotes(521) = "Look into my eyes and try to forget that you have a Macy's charge card!"
    quotes(522) = "Look!  A ladder!  Maybe it leads to heaven, or a sandwich!"
    quotes(523) = "Look!!  Karl Malden!"
    quotes(524) = "LOOK!!  Sullen American teens wearing MADRAS shorts and ``Flock of Seagulls'' HAIRCUTS!"
    quotes(525) = "LOOK!!!  I'm WALKING in my SLEEP again!!"
    quotes(526) = "LOU GRANT froze my ASSETS!!"
    quotes(527) = "Make me look like LINDA RONSTADT again!!"
    quotes(528) = "Mary Tyler Moore's SEVENTH HUSBAND is wearing my DACRON TANK TOP in a cheap hotel in HONOLULU!"
    quotes(529) = "Maybe we could paint GOLDIE HAWN a rich PRUSSIAN BLUE--"
    quotes(530) = "MERYL STREEP is my obstetrician!"
    quotes(531) = "MMM-MM!!  So THIS is BIO-NEBULATION!"
    quotes(532) = "Mmmmmm-MMMMMM!!  A plate of STEAMING PIECES of a PIG mixed with the shreds of SEVERAL CHICKENS!!...  Oh BOY!!  I'm about to swallow a TORN-OFF section of a COW'S LEFT LEG soaked in COTTONSEED OIL and SUGAR!!  ..  Let's see.. Next, I'll have the GROUND-UP flesh of CUTE, BABY LAMBS fried in the MELTED, FATTY TISSUES from a warm-blooded animal someone once PETTED!!  ...  YUM!!  That was GOOD!! For DESSERT, I'll have a TOFU BURGER with BEAN SPROUTS on a stone-ground, WHOLE WHEAT BUN!!"
    quotes(533) = "Mr and Mrs PED, can I borrow 26.7% of the RAYON TEXTILE production of the INDONESIAN archipelago?"
    quotes(534) = "My Aunt MAUREEN was a military advisor to IKE & TINA TURNER!!"
    quotes(535) = "My BIOLOGICAL ALARM CLOCK just went off..  It has noiseless DOZE FUNCTION and full kitchen!!"
    quotes(536) = "My CODE of ETHICS is vacationing at famed SCHROON LAKE in upstate New York!!"
    quotes(537) = "My DIGITAL WATCH has an automatic SNOOZE FEATURE!!"
    quotes(538) = "My EARS are GONE!!"
    quotes(539) = "My ELBOW is a remote FRENCH OUTPOST!!"
    quotes(540) = "My face is new, my license is expired, and I'm under a doctor's care!!!!"
    quotes(541) = "My FAVORITE group is 'QUESTION MARK & THE MYSTERIANS'..."
    quotes(542) = "My forehead feels like a PACKAGE of moist CRANBERRIES in a remote FRENCH OUTPOST!!"
    quotes(543) = "My haircut is totally traditional!"
    quotes(544) = "MY income is ALL disposable!"
    quotes(545) = "My LESLIE GORE record is BROKEN.."
    quotes(546) = "My LIBRARY CARD expired..."
    quotes(547) = "My life is a patio of fun!"
    quotes(548) = "My mind is a potato field..."
    quotes(549) = "My mind is making ashtrays in Dayton...."
    quotes(550) = "My nose feels like a bad Ronald Reagan movie..."
    quotes(551) = "..  my NOSE is NUMB!"
    quotes(552) = "..  My pants just went on a wild rampage through a Long Island Bowling Alley!!"
    quotes(553) = "My pants just went to high school in the Carlsbad Caverns!!!"
    quotes(554) = "My polyvinyl cowboy wallet was made in Hong Kong by Montgomery Clift!"
    quotes(555) = "My TOYOTA is built like a ... BAGEL with CREAM CHEESE!!"
    quotes(556) = "My uncle Murray conquered Egypt in 53 B.C.  And I can prove it too!!"
    quotes(557) = "..  My vaseline is RUNNING..."
    quotes(558) = "NANCY!!  Why is everything RED?!"
    quotes(559) = "NATHAN...  your PARENTS were in a CARCRASH!! They're VOIDED - They COLLAPSED They had no CHAINSAWS...  They had no MONEY MACHINES... They did PILLS in SKIMPY GRASS SKIRTS... Nathan, I EMULATED them...  but they were OFF-KEY..."
    quotes(560) = "NEWARK has been REZONED!!  DES MOINES has been REZONED!!"
    quotes(561) = "Nice decor!"
    quotes(562) = "Not enough people play SKEE-BALL..  They're always thinking about COCAINE or and ALIEN BEINGS!!"
    quotes(563) = "NOT fucking!! Also not a PACKAGE of LOOSE-LEAF PAPER!!"
    quotes(564) = "Not SENSUOUS...  only ``FROLICSOME''... and in need of DENTAL WORK...  in PAIN!!!"
    quotes(565) = "NOW do I get to blow out the CANLDES??"
    quotes(566) = "Now I am depressed..."
    quotes(567) = "Now I can join WEIGHT WATCHERS!"
    quotes(568) = "Now I need a suntan, a tennis lesson, Annette Funicello and two dozen Day-Glo orange paper jumpsuits!!"
    quotes(569) = "..  Now I think I just reached the state of HYPERTENSION that comes JUST BEFORE you see the TOTAL at the SAFEWAY CHECKOUT COUNTER!"
    quotes(570) = "Now I understand the meaning of ``THE MOD SQUAD''!"
    quotes(571) = "Now I'm being INVOLUNTARILY shuffled closer to the CLAM DIP with the BROKEN PLASTIC FORKS in it!!"
    quotes(572) = "Now I'm concentrating on a specific tank battle toward the end of World War II!"
    quotes(573) = "Now I'm having INSIPID THOUGHTS about the beautiful, round wives of HOLLYWOOD MOVIE MOGULS encased in PLEXIGLASS CARS and being approached by SMALL BOYS selling FRUIT.."
    quotes(574) = "Now I'm telling MISS PIGGY about MONEY MARKET FUNDS!"
    quotes(575) = "..  Now KEN and BARBIE are PERMANENTLY ADDICTED to MIND-ALTERING DRUGS.."
    quotes(576) = "Now KEN is having a MENTAL CRISIS beacuse his 'R.V.' PAYMENTS are OVER-DUE!!"
    quotes(577) = "Now my EMOTIONAL RESOURCES are heavily committed to 23% of the SMELTING and REFINING industry of the state of NEVADA!!"
    quotes(578) = "Now that I have my ``APPLE,'' I comprehend COST ACCOUNTING!!"
    quotes(579) = "Now that we're in LOVE, you can BUY this GOLDFISH for a 48% DISCOUNT."
    quotes(580) = "Now, I think it would be GOOD to buy FIVE or SIX STUDEBAKERS and CRUISE for ARTIFICIAL FLAVORING!!"
    quotes(581) = "NOW, I'm supposed to SCRAMBLE two, and HOLD th' MAYO!!"
    quotes(582) = "NOW, I'm taking the NEXT FLIGHT to ACAPULCO so I can write POEMS about BROKEN GUITAR STRINGS and sensuous PRE-TEENS!!"
    quotes(583) = "Now, let's SEND OUT for QUICHE!!"
    quotes(584) = "Now, my ENTIRE LIFE is flashing before my EYES as I park my DODGE DART in your EXXON service area for a COMPLETE LUBRICATION!!"
    quotes(585) = "O.K.!  Speak with a PHILADELPHIA ACCENT!!  Send out for CHINESE FOOD!! Hop a JET!"
    quotes(586) = "Of course, you UNDERSTAND about the PLAIDS in the SPIN CYCLE --"
    quotes(587) = "Oh my GOD -- the SUN just fell into YANKEE STADIUM!!"
    quotes(588) = "Oh, FISH sticks, CHEEZ WHIZ, GIN fizz, SHOW BIZ!!"
    quotes(589) = "Oh, I get it!!  ``The BEACH goes on,'' huh, SONNY??"
    quotes(590) = "OKAY!!  Turn on the sound ONLY for TRYNEL CARPETING, FULLY-EQUIPPED R.V.'S and FLOATATION SYSTEMS!!"
    quotes(591) = "Okay, BARBRA STREISAND, I recognize you now!!  Also EFREM ZIMBALIST, JUNIOR!!  And BEAUMONT NEWHALL!!  Everybody into th' BATHROOM!"
    quotes(592) = "Okay..  I'm going home to write the ``I HATE RUBIK's CUBE HANDBOOK FOR DEAD CAT LOVERS''.."
    quotes(593) = "OMNIVERSAL AWARENESS??  Oh, YEH!!  First you need 4 GALLONS of JELL-O and a BIG WRENCH!!...  I think you drop th'WRENCH in the JELL-O as if it was a FLAVOR, or an INGREDIENT...  ...or...I...um...  WHERE'S the WASHING MACHINES?"
    quotes(594) = "On SECOND thought, maybe I'll heat up some BAKED BEANS and watch REGIS PHILBIN..  It's GREAT to be ALIVE!!"
    quotes(595) = "On the other hand, life can be an endless parade of TRANSSEXUAL QUILTING BEES aboard a cruise ship to DISNEYWORLD if only we let it!!"
    quotes(596) = "On the road, ZIPPY is a pinhead without a purpose, but never without a POINT."
    quotes(597) = "..  Once upon a time, four AMPHIBIOUS HOG CALLERS attacked a family of DEFENSELESS, SENSITIVE COIN COLLECTORS and brought DOWN their PROPERTY VALUES!!"
    quotes(598) = "Once, there was NO fun...  This was before MENU planning, FASHION statements or NAUTILUS equipment... Then, in 1985..  FUN was completely encoded in this tiny MICROCHIP.. It contain 14,768 vaguely amusing SIT-COM pilots!! We had to wait FOUR BILLION years but we finally got JERRY LEWIS, MTV and a large selection of creme-filled snack cakes!"
    quotes(599) = "..  One FISHWICH coming up!!"
    quotes(600) = "ONE:  I will donate my entire ``BABY HUEY'' comic book collection to the downtown PLASMA CENTER.. TWO:  I won't START a BAND called ``KHADAFY & THE HIT SQUAD''.. THREE:  I won't ever TUMBLE DRY my FOX TERRIER again!!"
    quotes(601) = "..  or were you driving the PONTIAC that HONKED at me in MIAMI last Tuesday?"
    quotes(602) = "Our father who art in heaven..  I sincerely pray that SOMEBODY at this table will PAY for my SHREDDED WHAT and ENGLISH MUFFIN.. and also leave a GENEROUS TIP..."
    quotes(603) = "..  over in west Philadelphia a puppy is vomiting.."
    quotes(604) = "OVER the underpass!  UNDER the overpass!  Around the FUTURE and BEYOND REPAIR!!"
    quotes(605) = "PARDON me, am I speaking ENGLISH?"
    quotes(606) = "Pardon me, but do you know what it means to be TRULY ONE with your BOOTH!"
    quotes(607) = "PEGGY FLEMING is stealing BASKET BALLS to feed the babies in VERMONT."
    quotes(608) = "...PENGUINS are floating by..."
    quotes(609) = "PIZZA!!"
    quotes(610) = "Place me on a BUFFER counter while you BELITTLE several BELLHOPS in the Trianon Room!!  Let me one of your SUBSIDIARIES!"
    quotes(611) = "Please come home with me...  I have Tylenol!!"
    quotes(612) = "Psychoanalysis??  I thought this was a nude rap session!!!"
    quotes(613) = "PUNK ROCK!!  DISCO DUCK!!  BIRTH CONTROL!!"
    quotes(614) = "Put FIVE DOZEN red GIRDLES in each CIRCULAR OPENING!!"
    quotes(615) = "Quick, sing me the BUDAPEST NATIONAL ANTHEM!!"
    quotes(616) = "QUIET!!  I'm being CREATIVE!!  Is it GREAT yet?  It's s'posed to SMOKEY THE BEAR..."
    quotes(617) = "RELATIVES!!"
    quotes(618) = "RELAX!! ... This is gonna be a HEALING EXPERIENCE!!  Besides, I work for DING DONGS!"
    quotes(619) = "Remember, if you try to ESCAPE, many APARTMENT HOPPING ALCOHOLICS will SIMONIZE your HALLWAYS!!  This is your LAST WARNING!!"
    quotes(620) = "Remember, in 2039, MOUSSE & PASTA will be available ONLY by prescription!!"
    quotes(621) = "RHAPSODY in Glue!"
    quotes(622) = "SANTA CLAUS comes down a FIRE ESCAPE wearing bright blue LEG WARMERS..  He scrubs the POPE with a mild soap or detergent for 15 minutes, starring JANE FONDA!!"
    quotes(623) = "Send your questions to ``ASK ZIPPY'', Box 40474, San Francisco, CA 94140, USA"
    quotes(624) = "SHHHH!!  I hear SIX TATTOOED TRUCK-DRIVERS tossing ENGINE BLOCKS into empty OIL DRUMS.."
    quotes(625) = "Should I do my BOBBIE VINTON medley?"
    quotes(626) = "..  Should I get locked in the PRINCIPAL'S OFFICE today -- or have a VASECTOMY??"
    quotes(627) = "Should I start with the time I SWITCHED personalities with a BEATNIK hair stylist or my failure to refer five TEENAGERS to a good OCULIST?"
    quotes(628) = "Sign my PETITION."
    quotes(629) = "So this is what it feels like to be potato salad"
    quotes(630) = "..  So, if we convert SUPPLY-SIDE SOYBEAN FUTURES into HIGH-YIELD T-BILL INDICATORS, the PRE-INFLATIONARY risks will DWINDLE to a rate of 2 SHOPPING SPREES per EGGPLANT!!"
    quotes(631) = "..  someone in DAYTON, Ohio is selling USED CARPETS to a SERBO-CROATIAN"
    quotes(632) = "Someone is DROOLING on my collar!!"
    quotes(633) = "Sometime in 1993 NANCY SINATRA will lead a BLOODLESS COUP on GUAM!!"
    quotes(634) = "Somewhere in DOWNTOWN BURBANK a prostitute is OVERCOOKING a LAMB CHOP!!"
    quotes(635) = "Somewhere in suburban Honolulu, an unemployed bellhop is whipping up a batch of illegal psilocybin chop suey!!"
    quotes(636) = "Somewhere in Tenafly, New Jersey, a chiropractor is viewing ``Leave it to Beaver''!"
    quotes(637) = "Sorry, wrong ZIP CODE!!"
    quotes(638) = "Spreading peanut butter reminds me of opera!!  I wonder why?"
    quotes(639) = "TAILFINS!!  ...click..."
    quotes(640) = "Talking Pinhead Blues: Oh, I LOST my ``HELLO KITTY'' DOLL and I get BAD reception on  channel TWENTY-SIX!! Th'HOSTESS FACTORY is closin' down and I just heard ZASU PITTS  has been DEAD for YEARS..  (sniff) My PLATFORM SHOE collection was CHEWED up by th'dog, ALEXANDER  HAIG won't let me take a SHOWER 'til Easter.. (snurf) So I went to the kitchen, but WALNUT PANELING whup me  upside mah HAID!! (on no, no, no..  Heh, heh)"
    quotes(641) = "TAPPING?  You POLITICIANS!  Don't you realize that the END of the ``Wash Cycle'' is a TREASURED MOMENT for most people?!"
    quotes(642) = "TATTOOED MIDGETS are using ALFREDO in their SALAMI FACTORY!"
    quotes(643) = "Tex SEX!  The HOME of WHEELS!  The dripping of COFFEE!!  Take me to Minnesota but don't EMBARRASS me!!"
    quotes(644) = "Th' MIND is the Pizza Palace of th' SOUL"
    quotes(645) = "Th' PINK SOCK... soaking... soaking... soaking... Th' PINK SOCK... washing... washing... washing... Th' PINK SOCK... rinsing... rinsing... rinsing..."
    quotes(646) = "Thank god!!..  It's HENNY YOUNGMAN!!"
    quotes(647) = "That's a decision that can only be made between you & SY SPERLING!!"
    quotes(648) = "The appreciation of the average visual graphisticator alone is worth the whole suaveness and decadence which abounds!!"
    quotes(649) = "The entire CHINESE WOMEN'S VOLLEYBALL TEAM all share ONE personality -- and have since BIRTH!!"
    quotes(650) = "The fact that 47 PEOPLE are yelling and sweat is cascading down my SPINAL COLUMN is fairly enjoyable!!"
    quotes(651) = "The FALAFEL SANDWICH lands on my HEAD and I become a VEGETARIAN..."
    quotes(652) = "..  the HIGHWAY is made out of LIME JELLO and my HONDA is a barbequed OYSTER!  Yum!"
    quotes(653) = "The Korean War must have been fun."
    quotes(654) = "'THE LITTLE PINK FLESH SISTERS,' I saw them at th' FLUROESCENT BULB MAKERS CONVENTION..."
    quotes(655) = "The LOGARITHM of an ISOCELES TRIANGLE is TUESDAY WELD!!"
    quotes(656) = "..  the MYSTERIANS are in here with my CORDUROY SOAP DISH!!"
    quotes(657) = "The Osmonds!  You are all Osmonds!!  Throwing up on a freeway at dawn!!!"
    quotes(658) = "The PILLSBURY DOUGHBOY is CRYING for an END to BURT REYNOLDS movies!!"
    quotes(659) = "The PINK SOCKS were ORIGINALLY from 1952!! But they went to MARS around 1953!!"
    quotes(660) = "The SAME WAVE keeps coming in and COLLAPSING like a rayon MUU-MUU.."
    quotes(661) = "..The TENSION mounts as I MASSAGE your RIGHT ANKLE according to ancient Tibetan ACCOUNTING PROCEDURES..are you NEUROTIC yet??"
    quotes(662) = "Then, it's off to RED CHINA!!"
    quotes(663) = "There's a little picture of ED MCMAHON doing BAD THINGS to JOAN RIVERS in a $200,000 MALIBU BEACH HOUSE!!"
    quotes(664) = "There's a lot of BIG MONEY in MISERY if you have an AGENT!!"
    quotes(665) = "There's a SALE on STRETCH SOCKS down at the '7-11'!!"
    quotes(666) = "There's enough money here to buy 5000 cans of Noodle-Roni!"
    quotes(667) = "These PRESERVES should be FORCE-FED to PENTAGON OFFICIALS!!"
    quotes(668) = "They collapsed....  like nuns in the street... they had no teen appeal!"
    quotes(669) = "They don't hire PERSONAL PINHEADS, Mr. Toad!"
    quotes(670) = "This ASEXUAL PIG really BOILS my BLOOD...  He's so..so.....URGENT!!"
    quotes(671) = "This is a NO-FRILLS flight -- hold th' CANADIAN BACON!!"
    quotes(672) = "This is my WILLIAM BENDIX memorial CORNER where I worship William Bendix like a GOD!!"
    quotes(673) = "This is PLEASANT!"
    quotes(674) = "This MUST be a good party -- My RIB CAGE is being painfully pressed up against someone's MARTINI!!"
    quotes(675) = "..  this must be what it's like to be a COLLEGE GRADUATE!!"
    quotes(676) = "This PIZZA symbolizes my COMPLETE EMOTIONAL RECOVERY!!"
    quotes(677) = "This PORCUPINE knows his ZIPCODE..  And he has ``VISA''!!"
    quotes(678) = "This TOPS OFF my partygoing experience!  Someone I DON'T LIKE is talking to me about a HEART-WARMING European film.."
    quotes(679) = "Those aren't WINOS--that's my JUGGLER, my AERIALIST, my SWORD SWALLOWER, and my LATEX NOVELTY SUPPLIER!!"
    quotes(680) = "Thousands of days of civilians ...  have produced a... feeling for the aesthetic modules --"
    quotes(681) = "Three attractive BANK ROBBERS are discussing RELIGIOUS DIFFERENCES and MAKE-UP TECHNIQUE with them!!"
    quotes(682) = "Today, THREE WINOS from DETROIT sold me a framed photo of TAB HUNTER before his MAKEOVER!"
    quotes(683) = "Toes, knees, NIPPLES.  Toes, knees, nipples, KNUCKLES... Nipples, dimples, knuckles, NICKLES, wrinkles, pimples!! I don't like FRANK SINATRA or his CHILDREN."
    quotes(684) = "TONY RANDALL!  Is YOUR life a PATIO of FUN??"
    quotes(685) = "Two LITTLE black dots and one BIG black dot...nice 'n' FLUFFY!!"
    quotes(686) = "Two with FLUFFO, hold th' BEETS..side of SOYETTES!"
    quotes(687) = "Uh-oh --  WHY am I suddenly thinking of a VENERABLE religious leader frolicking on a FORT LAUDERDALE weekend?"
    quotes(688) = "Uh-oh!!  I forgot to submit to COMPULSORY URINALYSIS!"
    quotes(689) = "UH-OH!!  I put on ``GREAT HEAD-ON TRAIN COLLISIONS of the 50's'' by mistake!!!"
    quotes(690) = "UH-OH!!  I think KEN is OVER-DUE on his R.V. PAYMENTS and HE'S having a NERVOUS BREAKDOWN too!!  Ha ha."
    quotes(691) = "Uh-oh!!  I'm having TOO MUCH FUN!!"
    quotes(692) = "UH-OH!!  We're out of AUTOMOBILE PARTS and RUBBER GOODS!"
    quotes(693) = "...Um...Um..."
    quotes(694) = "Used staples are good with SOY SAUCE!"
    quotes(695) = "Vote for ME -- I'm well-tapered, half-cocked, ill-conceived and TAX-DEFERRED!"
    quotes(696) = "..Wait 'til those  ITALIAN TEENAGERS get back to their HONDAS & discover them to be FILLED to the BRIM with MAZOLA!!"
    quotes(697) = "Wait..  is this a FUN THING or the END of LIFE in Petticoat Junction??"
    quotes(698) = "Was my SOY LOAF left out in th'RAIN?  It tastes REAL GOOD!!"
    quotes(699) = "We are now enjoying total mutual interaction in an imaginary hot tub..."
    quotes(700) = "We have DIFFERENT amounts of HAIR --"
    quotes(701) = "We just joined the civil hair patrol!"
    quotes(702) = "We place two copies of PEOPLE magazine in a DARK, HUMID mobile home. 45 minutes later CYNDI LAUPER emerges wearing a BIRD CAGE on her head!"
    quotes(703) = "Well, here I am in AMERICA..  I LIKE it.  I HATE it.  I LIKE it.  I HATE it.  I LIKE it.  I HATE it.  I LIKE it.I HATE it.  I LIKE..  EMOTIONS are SWEEPING over me!!"
    quotes(704) = "Well, I'm a classic ANAL RETENTIVE!!  And I'm looking for a way to VICARIOUSLY experience some reason to LIVE!!"
    quotes(705) = "Well, I'm INVISIBLE AGAIN..  I might as well pay a visit to the LADIES ROOM..."
    quotes(706) = "Well, I'm on the right planet---everyone looks like me!!!"
    quotes(707) = "Well, O.K.  I'll compromise with my principles because of EXISTENTIAL DESPAIR!"
    quotes(708) = "Were these parsnips CORRECTLY MARINATED in TACO SAUCE?"
    quotes(709) = "What a COINCIDENCE!  I'm an authorized ``SNOOTS OF THE STARS'' dealer!!"
    quotes(710) = "What GOOD is a CARDBOARD suitcase ANYWAY?"
    quotes(711) = "What I need is a MATURE RELATIONSHIP with a FLOPPY DISK..."
    quotes(712) = "What I want to find out is -- do parrots know much about Astro-Turf?"
    quotes(713) = "What PROGRAM are they watching?"
    quotes(714) = "What UNIVERSE is this, please??"
    quotes(715) = "What's the MATTER Sid?..  Is your BEVERAGE unsatisfactory?"
    quotes(716) = "When I met th'POPE back in '58, I scrubbed him with a MILD SOAP or DETERGENT for 15 minutes.  He seemed to enjoy it.."
    quotes(717) = "When this load is DONE I think I'll wash it AGAIN.."
    quotes(718) = "When you get your PH.D. will you get able to work at BURGER KING?"
    quotes(719) = "When you said ``HEAVILY FORESTED'' it reminded me of an overdue CLEANING BILL..  Don't you SEE?  O'Grogan SWALLOWED a VALUABLE COIN COLLECTION and HAD to murder the ONLY MAN who KNEW!!"
    quotes(720) = "Where do your SOCKS go when you lose them in th' WASHER?"
    quotes(721) = "Where does it go when you flush?"
    quotes(722) = "Where's my SOCIAL WORKER?"
    quotes(723) = "Where's SANDY DUNCAN?"
    quotes(724) = "Where's th' DAFFY DUCK EXHIBIT??"
    quotes(725) = "Where's the Coke machine?  Tell me a joke!!"
    quotes(726) = "While I'm in LEVITTOWN I thought I'd like to see the NUCLEAR FAMILY!!"
    quotes(727) = "While my BRAINPAN is being refused service in BURGER KING, Jesuit priests are DATING CAREER DIPLOMATS!!"
    quotes(728) = "While you're chewing, think of STEVEN SPIELBERG'S bank account..  This will have the same effect as two ``STARCH BLOCKERS''!"
    quotes(729) = "WHO sees a BEACH BUNNY sobbing on a SHAG RUG?!"
    quotes(730) = "Who wants some OYSTERS with SEN-SEN an' COOL WHIP?"
    quotes(731) = "WHOA!!  I'm having a RELIGIOUS EXPERIENCE right NOW!!"
    quotes(732) = "WHOA!!  Ken and Barbie are having TOO MUCH FUN!!  It must be the NEGATIVE IONS!!"
    quotes(733) = "Why am I in this ROOM in DOWNTOWN PHILADELPHIA?"
    quotes(734) = "Why are these athletic shoe salesmen following me??"
    quotes(735) = "WHY are we missing KOJAK?"
    quotes(736) = "Why don't you ever enter and CONTESTS, Marvin?? Don't you know your own ZIPCODE?"
    quotes(737) = "Why is everything made of Lycra Spandex?"
    quotes(738) = "Why is it that when you DIE, you can't take your HOME ENTERTAINMENT CENTER with you??"
    quotes(739) = "Why was I BORN?"
    quotes(740) = "Will it improve my CASH FLOW?"
    quotes(741) = "Will the third world war keep ``Bosom Buddies'' off the air?"
    quotes(742) = "Will this never-ending series of PLEASURABLE EVENTS never cease?"
    quotes(743) = "With this weapon I can expose fictional characters and bring about sweeping reforms!!"
    quotes(744) = "With YOU, I can be MYSELF..  We don't NEED Dan Rather.."
    quotes(745) = "World War Three can be averted by adherence to a strictly enforced dress code!"
    quotes(746) = "Wow!  Look!!  A stray meatball!!  Let's interview it!"
    quotes(747) = "Xerox your lunch and file it under ``sex offenders!''"
    quotes(748) = "Yes, but will I see the EASTER BUNNY in skintight leather at an IRON MAIDEN concert?"
    quotes(749) = "Yes, Private DOBERMAN!!"
    quotes(750) = "You can't hurt me!!  I have an ASSUMABLE MORTGAGE!!"
    quotes(751) = "You mean now I can SHOOT YOU in the back and further BLUR th' distinction between FANTASY and REALITY?"
    quotes(752) = "You mean you don't want to watch WRESTLING from ATLANTA?"
    quotes(753) = "You must be a CUB SCOUT!!  Have you made your MONEY-DROP today??"
    quotes(754) = "YOU PICKED KARL MALDEN'S NOSE!!"
    quotes(755) = "You should all JUMP UP AND DOWN for TWO HOURS while I decide on a NEW CAREER!!"
    quotes(756) = "You were s'posed to laugh!"
    quotes(757) = "YOU!!  Give me the CUTEST, PINKEST, most charming little VICTORIAN DOLLHOUSE you can find!!  An make it SNAPPY!!"
    quotes(758) = "YOU'D cry too if it happened to YOU!!"
    quotes(759) = "Your CHEEKS sit like twin NECTARINES above a MOUTH that knows no BOUNDS --"
    quotes(760) = "Youth of today!  Join me in a mass rally for traditional mental attitudes!"
    quotes(761) = "Yow!"
    quotes(762) = "Yow!  Am I cleansed yet?!"
    quotes(763) = "Yow!  Am I having fun yet?"
    quotes(764) = "Yow!  Am I in Milwaukee?"
    quotes(765) = "Yow!  Am I JOGGING yet??"
    quotes(766) = "Yow!  And then we could sit on the hoods of cars at stop lights!"
    quotes(767) = "Yow!  Are we in the perfect mood?"
    quotes(768) = "Yow!  Are we laid back yet?"
    quotes(769) = "Yow!  Are we wet yet?"
    quotes(770) = "Yow!  Are you the self-frying president?"
    quotes(771) = "Yow!  Did something bad happen or am I in a drive-in movie??"
    quotes(772) = "YOW!  I can see 1987!!  PRESIDENT FORD is doing the REMAKE of 'PAGAN LOVE SONG'...he's playing ESTHER WILLIAMS!!"
    quotes(773) = "Yow!  I forgot my PAIL!!"
    quotes(774) = "Yow!  I just went below the poverty line!"
    quotes(775) = "Yow!  I like my new DENTIST..."
    quotes(776) = "Yow!  I threw up on my window!"
    quotes(777) = "Yow!  I want my nose in lights!"
    quotes(778) = "Yow!  I want to mail a bronzed artichoke to Nicaragua!"
    quotes(779) = "Yow!  I'm having a quadraphonic sensation of two winos alone in a steel mill!"
    quotes(780) = "Yow!  I'm imagining a surfer van filled with soy sauce!"
    quotes(781) = "Yow!  I'm out of work...I could go into shock absorbers...or SCUBA GEAR!!"
    quotes(782) = "Yow!  I'm UNEMPLOYED!"
    quotes(783) = "Yow!  Is my fallout shelter termite proof?"
    quotes(784) = "Yow!  Is this sexual intercourse yet??  Is it, huh, is it??"
    quotes(785) = "Yow!  It's a hole all the way to downtown Burbank!"
    quotes(786) = "Yow!  It's some people inside the wall!  This is better than mopping!"
    quotes(787) = "Yow!  Maybe I should have asked for my Neutron Bomb in PAISLEY--"
    quotes(788) = "Yow!  Now I get to think about all the BAD THINGS I did to a BOWLING BALL when I was in JUNIOR HIGH SCHOOL!"
    quotes(789) = "Yow!  Now we can become alcoholics!"
    quotes(790) = "Yow!  STYROFOAM.."
    quotes(791) = "Yow!  Those people look exactly like Donnie and Marie Osmond!!"
    quotes(792) = "Yow!  We're going to a new disco!"
    quotes(793) = "YOW!!"
    quotes(794) = "Yow!!  'Janitor trapped in sewer uses ESP to find decayed burger'!!"
    quotes(795) = "YOW!!  Everybody out of the GENETIC POOL!"
    quotes(796) = "YOW!!  I am having FUN!!"
    quotes(797) = "YOW!!  I'm in a very clever and adorable INSANE ASYLUM!!"
    quotes(798) = "Yow!!  It's LIBERACE and TUESDAY WELD!!  High on a HILL... driving a LITTLE CAR...  I wanna be in that LITTLE CAR, too!!  I wanna drive off with LIBBY and TUESDAY!"
    quotes(799) = "YOW!!  Now I understand advanced MICROBIOLOGY and th' new TAX REFORM laws!!"
    quotes(800) = "YOW!!  Now I'm playing with my HOLOGRAPHIC ATOMIC SIMULATION LASER pinball machine!!  WORLD PEACE is in the BALANCE!!"
    quotes(801) = "Yow!!  That's a GOOD IDEA!!  Eating a whole FIELD of COUGH MEDICINE should make you feel MUCH BETTER!!"
    quotes(802) = "YOW!!  The land of the rising SONY!!"
    quotes(803) = "YOW!!  Up ahead!  It's a DONUT HUT!!"
    quotes(804) = "YOW!!  What should the entire human race DO??  Consume a fifth of CHIVAS REGAL, ski NUDE down MT. EVEREST, and have a wild SEX WEEKEND!"
    quotes(805) = "YOW!!!  I am having fun!!!"
    quotes(806) = "YUGGA-HUGGA-BUGGA-TUGGA!!  HEY-HEY!!  A TRAIN STATION!!  No, a POST OFFICE!!  An OCEAN LINER!!  No, I think it's a CAFETERIA!!!"
    quotes(807) = "Zippy's brain cells are straining to bridge synapses..."

    CALL MondoLogPlain("Zippy sez: "//TRIM(quotes(Random((/ 1, SIZE(quotes) /)))))

  END SUBROUTINE ZippySez
END MODULE ZippyQuote
